import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
// @ts-ignore

import { MapMouseEvent } from "./events";
export default class BlockableMapEventHandler {
  constructor(map) {
    _defineProperty(this, "map", void 0);
    _defineProperty(this, "delayContextMenu", void 0);
    _defineProperty(this, "contextMenuEvent", void 0);
    this.map = map;
  }
  reset() {
    this.delayContextMenu = false;
    // @ts-ignore
    delete this.contextMenuEvent;
  }
  mousemove(e) {
    // mousemove map events should not be fired when interaction handlers (pan, rotate, etc) are active
    this.map.emit(e.type, new MapMouseEvent(e.type, this.map, e));
  }
  mousedown() {
    this.delayContextMenu = true;
  }
  mouseup() {
    this.delayContextMenu = false;
    if (this.contextMenuEvent) {
      this.map.emit('contextmenu', new MapMouseEvent('contextmenu', this.map, this.contextMenuEvent));
      // @ts-ignore
      delete this.contextMenuEvent;
    }
  }
  contextmenu(e) {
    if (this.delayContextMenu) {
      // Mac: contextmenu fired on mousedown; we save it until mouseup for consistency's sake
      this.contextMenuEvent = e;
    } else {
      // Windows: contextmenu fired on mouseup, so fire event now
      this.map.emit(e.type, new MapMouseEvent(e.type, this.map, e));
    }

    // prevent browser context menu when necessary
    if (this.map.listeners('contextmenu')) {
      e.preventDefault();
    }
  }
  isEnabled() {
    return true;
  }
  isActive() {
    return false;
  }
  enable() {
    return true;
  }
  disable() {
    return false;
  }
}