import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
// @ts-ignore

export default class ClickZoomHandler {
  constructor() {
    _defineProperty(this, "enabled", void 0);
    _defineProperty(this, "active", void 0);
    this.reset();
  }
  reset() {
    this.active = false;
  }
  dblclick(e, point) {
    e.preventDefault();
    return {
      cameraAnimation: map => {
        map.easeTo({
          duration: 300,
          zoom: map.getZoom() + (e.shiftKey ? -1 : 1),
          around: map.unproject(point)
        }, {
          originalEvent: e
        });
      }
    };
  }
  enable() {
    this.enabled = true;
  }
  disable() {
    this.enabled = false;
    this.reset();
  }
  isEnabled() {
    return this.enabled;
  }
  isActive() {
    return this.active;
  }
}