// @ts-ignore

import MouseHandler from "./mouse_handler";
import { LEFT_BUTTON, RIGHT_BUTTON } from "./util";
export default class MouseRotateHandler extends MouseHandler {
  contextmenu(e) {
    // prevent browser context menu when necessary; we don't allow it with rotation
    // because we can't discern rotation gesture start from contextmenu on Mac
    e.preventDefault();
  }
  correctButton(e, button) {
    return button === LEFT_BUTTON && e.ctrlKey || button === RIGHT_BUTTON;
  }
  move(lastPoint, point) {
    const degreesPerPixelMoved = 0.8;
    const bearingDelta = (point.x - lastPoint.x) * degreesPerPixelMoved;
    if (bearingDelta) {
      this.active = true;
      return {
        bearingDelta
      };
    }
  }
}