"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _l7Utils = require("@antv/l7-utils");
var _dom = _interopRequireDefault(require("../../utils/dom"));
var _event = require("./event");
// @ts-ignore
// tslint:disable-next-line:no-submodule-imports

const {
  merge
} = _l7Utils.lodashUtil;
class MapMouseEvent extends _event.Event {
  /**
   * @private
   */
  constructor(type, map, originalEvent, data = {}) {
    const point = _dom.default.mousePos(map.getCanvasContainer(), originalEvent);
    const lngLat = map.unproject(point);
    super(type, merge({
      point,
      lngLat,
      originalEvent
    }, data));
    /**
     * `true` if `preventDefault` has been called.
     * @private
     */
    /**
     * The `Map` object that fired the event.
     */
    (0, _defineProperty2.default)(this, "target", void 0);
    /**
     * The DOM event which caused the map event.
     */
    (0, _defineProperty2.default)(this, "originalEvent", void 0);
    /**
     * The pixel coordinates of the mouse cursor, relative to the map and measured from the top left corner.
     */
    (0, _defineProperty2.default)(this, "point", void 0);
    /**
     * The geographic location on the map of the mouse cursor.
     */
    (0, _defineProperty2.default)(this, "lngLat", void 0);
    (0, _defineProperty2.default)(this, "defaultPrevented", void 0);
    this.defaultPrevented = false;
    this.target = map;
  }
  preventDefault() {
    this.defaultPrevented = true;
  }
}
exports.default = MapMouseEvent;