"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _event = require("./event");
class MapWheelEvent extends _event.Event {
  /**
   * @private
   */
  constructor(type, map, originalEvent) {
    super(type, {
      originalEvent
    });
    /**
     * The event type.
     */
    /**
     * The DOM event which caused the map event.
     */
    (0, _defineProperty2.default)(this, "originalEvent", void 0);
    (0, _defineProperty2.default)(this, "defaultPrevented", void 0);
    /**
     * The `Map` object that fired the event.
     */
    (0, _defineProperty2.default)(this, "target", void 0);
    this.defaultPrevented = false;
  }

  /**
   * Prevents subsequent default processing of the event by the map.
   *
   * Calling this method will prevent the the behavior of {@link ScrollZoomHandler}.
   */
  preventDefault() {
    this.defaultPrevented = true;
  }
}
exports.default = MapWheelEvent;