"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _mouse_handler = _interopRequireDefault(require("./mouse_handler"));
var _util = require("./util");
// @ts-ignore

class MousePitchHandler extends _mouse_handler.default {
  correctButton(e, button) {
    return button === _util.LEFT_BUTTON && e.ctrlKey || button === _util.RIGHT_BUTTON;
  }
  move(lastPoint, point) {
    const degreesPerPixelMoved = -0.5;
    const pitchDelta = (point.y - lastPoint.y) * degreesPerPixelMoved;
    if (pitchDelta) {
      this.active = true;
      return {
        pitchDelta
      };
    }
  }
  contextmenu(e) {
    // prevent browser context menu when necessary; we don't allow it with rotation
    // because we can't discern rotation gesture start from contextmenu on Mac
    e.preventDefault();
  }
}
exports.default = MousePitchHandler;