"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _mouse_handler = _interopRequireDefault(require("./mouse_handler"));
var _util = require("./util");
// @ts-ignore

class MouseRotateHandler extends _mouse_handler.default {
  contextmenu(e) {
    // prevent browser context menu when necessary; we don't allow it with rotation
    // because we can't discern rotation gesture start from contextmenu on Mac
    e.preventDefault();
  }
  correctButton(e, button) {
    return button === _util.LEFT_BUTTON && e.ctrlKey || button === _util.RIGHT_BUTTON;
  }
  move(lastPoint, point) {
    const degreesPerPixelMoved = 0.8;
    const bearingDelta = (point.x - lastPoint.x) * degreesPerPixelMoved;
    if (bearingDelta) {
      this.active = true;
      return {
        bearingDelta
      };
    }
  }
}
exports.default = MouseRotateHandler;