"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _two_touch = _interopRequireDefault(require("./two_touch"));
// @ts-ignore

const ZOOM_THRESHOLD = 0.1;
function getZoomDelta(distance, lastDistance) {
  return Math.log(distance / lastDistance) / Math.LN2;
}
class TouchZoomHandler extends _two_touch.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "distance", void 0);
    (0, _defineProperty2.default)(this, "startDistance", void 0);
  }
  reset() {
    super.reset();
    // @ts-ignore
    delete this.distance;
    // @ts-ignore
    delete this.startDistance;
  }
  start(points) {
    this.startDistance = this.distance = points[0].dist(points[1]);
  }
  move(points, pinchAround) {
    const lastDistance = this.distance;
    this.distance = points[0].dist(points[1]);
    if (!this.active && Math.abs(getZoomDelta(this.distance, this.startDistance)) < ZOOM_THRESHOLD) {
      return;
    }
    this.active = true;
    return {
      zoomDelta: getZoomDelta(this.distance, lastDistance),
      pinchAround
    };
  }
}
exports.default = TouchZoomHandler;